#ifndef Lib_ZipWriter_h
#define Lib_ZipWriter_h

#include <Slash/Core/IWriter.h>

namespace Slash {namespace Core {class IWriter;}}

namespace Lib {

class ZipWriter : public virtual Slash::Core::IWriter {
public: //Lib::Slash::Core::IWriter
  virtual bool write(const std::string&);
  virtual void disable();
  virtual void enable();
  virtual bool enabled() const;
  virtual bool flush();
public:
  static bool available();
public:
  ZipWriter(const std::string&,Slash::Core::IWriter&);
  virtual ~ZipWriter();
  bool openEntry(const std::string&);
  bool closeEntry();
private:
  Slash::Core::IWriter& fPrinter;
  std::string fFileName;
  void* fFile;
  bool fEntryOpened;
};

}

#endif
