#ifndef amanip_file_h
#define amanip_file_h

#include <string>
#include <vector>
#include <cstdio>
#include <cstring> //strlen

namespace amanip {

inline bool write(const std::string& a_file,const std::vector<std::string>& a_text){
  FILE* file = ::fopen(a_file.c_str(),"wb");
  if(!file) return false;
  unsigned int textn = a_text.size();
  for(unsigned index=0;index<textn;index++) {
    if(::fprintf(file,"%s\n",a_text[index].c_str())<0) {
      ::fclose(file);
      return false;
    }
  }
  ::fclose(file);
  return true;
}

inline bool read(const std::string& a_file,std::vector<std::string>& a_text){
  a_text.clear();
  //FIXME : should read without a limited buffer.
  FILE* file = ::fopen(a_file.c_str(),"rb");
  if(!file) return false;
  unsigned int BUFSIZE = 65536;
  char* buffer = new char[BUFSIZE+1];
  if(!buffer) {::fclose(file);return false;}
  while(true) {
    if(::fgets(buffer,BUFSIZE,(FILE*)file)==NULL) break; // EOF.
    int l = ::strlen(buffer);
    //  On Windows, editors when saving binary files,
    // put \r\n at place of \n ; we then look for \r\n.
    if( (l>=2) && (buffer[l-2]=='\r') && (buffer[l-1]=='\n') ) {
      buffer[l-2] = '\0';
    } else if( (l>=1) && (buffer[l-1]=='\n') ) {
      buffer[l-1] = '\0';
    }
    a_text.push_back(buffer);
  }
  delete [] buffer;
  ::fclose(file);
  return true;
}

inline bool remove(const std::string& a_file) {
  return (::remove(a_file.c_str()) ==0 ? true : false);
}

inline bool write(const std::string& a_file,const std::string& a_string){
  // a_string could contain \n separated lines.
  FILE* file = ::fopen(a_file.c_str(),"wb");
  if(!file) return false;
  if(::fprintf(file,"%s",a_string.c_str())<0) {
    ::fclose(file);
    return false;
  }
  ::fclose(file);
  return true;
}

}

#include <sys/stat.h>

namespace amanip {

inline bool tmpname(std::string& a_file
,const std::string& a_pref
,const std::string& a_suff
){
  //  For UNIX aDir must be a string ended with '/'. Exa : /tmp/ .
  for(int count=0;count<1000;count++) {
    char name[4];
    ::sprintf(name,"%03d",count);
    std::string tmpnm;
    tmpnm += a_pref;
    tmpnm += name;
    tmpnm += a_suff;
    struct stat finfo;
    if(::stat(tmpnm.c_str(),&finfo) < 0) {
      // No directory or file found :
      a_file = tmpnm; // Good file name.
      return true; 
    }
  }
  // No good name found :
  a_file = "";
  return false;
}

}

#endif
