
#
#  Usage :
#    csh> source <osc_vis_path>/SDL-setup.csh
#

#set verbose

set SDL_home=none
if ( "`uname -n | grep lxplus`" != "" ) then
  if ( `uname -m` == "x86_64" ) then
    set SDL_home="/afs/cern.ch/sw/contrib/SDL/1.2.11/slc4_amd64_gcc34"
  else
    set SDL_home="/afs/cern.ch/sw/contrib/SDL/1.2.11/slc4_ia32_gcc34"
  endif
else
  if ( `uname` == Darwin ) then
    set SDL_home=/Library/Frameworks
  endif
endif

if ( "${SDL_home}" != "none" ) then

if ( `uname` == "Linux" ) then
  set lib_path="${SDL_home}/lib"
  set lib_curr=`printenv LD_LIBRARY_PATH`
  if ( "${lib_curr}" == "" ) then
    setenv LD_LIBRARY_PATH "${lib_path}"
  else
    if ( `echo "${lib_curr}" | grep "${lib_path}" ` == "" ) then
      setenv LD_LIBRARY_PATH "${LD_LIBRARY_PATH}:${lib_path}"
    endif
  endif
  unset lib_curr
  unset lib_path
endif

if ( `uname` == "Darwin" ) then

  set lib_path="${SDL_home}/SDL.framework"

  set lib_curr=`printenv DYLD_LIBRARY_PATH`
  if ( "${lib_curr}" == "" ) then
    setenv DYLD_LIBRARY_PATH "${lib_path}"
  else
    if ( `echo "${lib_curr}" | grep "${lib_path}" ` == "" ) then
      setenv DYLD_LIBRARY_PATH "${DYLD_LIBRARY_PATH}:${lib_path}"
    endif
  endif
  unset lib_curr
  unset lib_path
endif

set bin_path="${SDL_home}/bin"
set bin_curr=`printenv PATH`
if ( "${bin_curr}" == "" ) then
 setenv PATH "${bin_path}"
else
 if ( `echo "${bin_curr}" | grep "${bin_path}" ` == "" ) then
   setenv PATH "${PATH}:${bin_path}"
 endif
endif
unset bin_curr
unset bin_path

endif

unset SDL_home
